; aPLib 6502 depacker for C64 by Francisco Crespo (Black Hole)
; Based on an earlier 65C02 depacker for Apple IIc by Peter Ferrie
*       =   $0801
        .word (+), 2005  ;pointer, line number
        .null $9e, format("%d", start);will be sys 4096
+       .word 0          ;basic line end

start   
; Depacker variables
TMPY    =   $A7
tmp     =   $A8 ; A8/A9
newsrc  =   $AA ; AA/AB
ecx     =   $F7 ; F7/F8
last    =   $F9 ; F9/FA
src     =   $FB ; FB/FC
dst     =   $FD ; FD/FE

            lda     #end_depack & $ff
            sta     src
            lda     #end_depack >> 8
            sta     src+1

            lda     #$00
            sta     dst
            lda     #$10
            sta     dst+1
; break 81d  sw reset  103383-103420-103465
            sei
            jsr     depack
            cli
            
GETBIT_M    .macro
            txa
            asl
            bne     kk
            lda     (src),Y
            inc     src
            bne     +
            inc     src+1
+           rol     a
kk          tax
            .endm

GETSRC_M    .macro
            LDA     (src),Y
            INC     src
            BNE     +
            INC     src+1
+
            .endm

PUTDST_M    .macro
            STA     (dst),Y
            INC     dst
            BNE     +
            INC     dst+1
+
            .endm

depack:     LDX     #$80
            LDY     #$00
            STY     ecx+1           ; Y=0

literal:    GETSRC_M
            PUTDST_M
            ;ldy    #2
            LDA     #$02
            STA     TMPY

nexttag:    GETBIT_M
            bcc     literal
            GETBIT_M
            bcc     codepair
            GETBIT_M
            bcs     onebyte
            GETSRC_M
            lsr
            beq     donedepacking
            STY     ecx             ; Y=0
            rol     ecx
            sta     last
            STY     last+1          ; Y=0
            JMP     domatch_with_2inc

donedepacking:
            RTS

onebyte:
            ;ldy    #1
            ;sty    ecx
            ;iny
            LDA     #1
            STA     ecx
            LDA     #2
            STA     TMPY
            lda     #$10

getmorebits:
            pha
            GETBIT_M
            pla
            rol
            bcc     getmorebits
            STY     tmp+1           ; Y=0
            bne     domatch
            PUTDST_M
            JMP     nexttag

codepair:   jsr     getgamma
            LDA     ecx
            SEC
            SBC     TMPY
            STA     TMPY
            ora     ecx+1
            bne     normalcodepair
            jsr     getgamma
            JMP     domatch_lastpos

normalcodepair:
            GETSRC_M
            sta     last
            jsr     getgamma
            ;dey
            ;sty    last+1
            dec     TMPY
            LDA     TMPY
            STA     last+1
            ;cpy    #$7d
            CMP     #$7D
            bcs     domatch_with_2inc
            ;cpy    #5
            CMP     #$05
            bcs     domatch_with_inc
            lda     last
            bmi     domatch_lastpos
            ;tya
            LDA     TMPY
            bne     domatch_lastpos

domatch_with_2inc:
            inc     ecx
            bne     domatch_with_inc
            inc     ecx+1

domatch_with_inc:
            inc     ecx
            bne     domatch_lastpos
            inc     ecx+1

domatch_lastpos:
            ;ldy    #1
            LDA     #1
            STA     TMPY
            lda     last+1
            sta     tmp+1
            lda     last

domatch:    sta     tmp
            lda     dst
            sec
            sbc     tmp
            sta     newsrc
            lda     dst+1
            sbc     tmp+1
            sta     newsrc+1

            lda     ecx
            beq     dloop
-           LDA     (newsrc),Y
            INC     newsrc
            BNE     +
            INC     newsrc+1
+           PUTDST_M
            dec     ecx
            bne     -
            lda     ecx+1
            beq     kkk

dloop:      LDA     (newsrc),Y
            INC     newsrc
            BNE     ll
            INC     newsrc+1
ll          PUTDST_M
            dec     ecx
            bne     dloop
            dec     ecx+1
            bne     dloop
kkk         JMP     nexttag

getgamma:   LDA     #$01
            STA     ecx
            STY     ecx+1           ; Y=0

            txa                     ; GETBIT_1
gloop:      asl     a
            bne     gloop2
            lda     (src),Y
            inc     src
            bne     gloop1
            inc     src+1
gloop1:     rol     a

gloop2:     rol     ecx
            rol     ecx+1

            asl     a               ; GETBIT_2
            bne     mm
            lda     (src),Y
            inc     src
            bne     +
            inc     src+1
+           rol     a
mm          bcs     gloop
            tax                     ; stillbitsleft

            rts

end_depack: .binary  "alice1k.pck"
